aboutsummaryrefslogtreecommitdiff
path: root/src/test/test_rebind.sh
diff options
context:
space:
mode:
authorteor <teor@torproject.org>2019-10-31 00:58:09 +1000
committerteor <teor@torproject.org>2019-11-05 11:07:31 +1000
commit5b04db59f69332ac6d44e12ad759e224a9cd3b99 (patch)
tree5813b8ac650a779b1ab955d2170a394f73d2d45e /src/test/test_rebind.sh
parentf29de4b8d2097676f9d2f067c176b38a08362046 (diff)
downloadtor-5b04db59f69332ac6d44e12ad759e224a9cd3b99.tar.gz
tor-5b04db59f69332ac6d44e12ad759e224a9cd3b99.zip
test/scripts: Use the same code to find the tor binary
This change makes sure we are always using the coverage binary, when coverage is enabled. Fixes bug 32368; bugfix on 0.2.7.3-rc.
Diffstat (limited to 'src/test/test_rebind.sh')
-rwxr-xr-xsrc/test/test_rebind.sh32
1 files changed, 30 insertions, 2 deletions
diff --git a/src/test/test_rebind.sh b/src/test/test_rebind.sh
index 62c9283fc9..879008c1c1 100755
--- a/src/test/test_rebind.sh
+++ b/src/test/test_rebind.sh
@@ -1,7 +1,23 @@
#!/bin/sh
+umask 077
+set -e
set -x
+# emulate realpath(), in case coreutils or equivalent is not installed.
+abspath() {
+ f="$*"
+ if [ -d "$f" ]; then
+ dir="$f"
+ base=""
+ else
+ dir="$(dirname "$f")"
+ base="/$(basename "$f")"
+ fi
+ dir="$(cd "$dir" && pwd)"
+ echo "$dir$base"
+}
+
UNAME_OS=$(uname -s | cut -d_ -f1)
if test "$UNAME_OS" = 'CYGWIN' || \
test "$UNAME_OS" = 'MSYS' || \
@@ -12,7 +28,19 @@ if test "$UNAME_OS" = 'CYGWIN' || \
fi
fi
-if "${TESTING_TOR_BINARY}" --list-modules | grep -q "relay: no"; then
+# find the tor binary
+if [ $# -ge 1 ]; then
+ TOR_BINARY="${1}"
+ shift
+else
+ TOR_BINARY="${TESTING_TOR_BINARY:-./src/app/tor}"
+fi
+
+TOR_BINARY="$(abspath "$TOR_BINARY")"
+
+echo "TOR BINARY IS ${TOR_BINARY}"
+
+if "${TOR_BINARY}" --list-modules | grep -q "relay: no"; then
echo "This test requires the relay module. Skipping." >&2
exit 77
fi
@@ -35,6 +63,6 @@ elif [ ! -d "$tmpdir" ]; then
exit 3
fi
-"${PYTHON:-python}" "${abs_top_srcdir:-.}/src/test/test_rebind.py" "${TESTING_TOR_BINARY}" "$tmpdir"
+"${PYTHON:-python}" "${abs_top_srcdir:-.}/src/test/test_rebind.py" "${TOR_BINARY}" "$tmpdir"
exit $?